/*
 * Copyright: (C) 1999 Bruce W. Forsberg
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 *
 *   Bruce Forsberg  forsberg@adnc.com
 *
 */

#include "aflibAudioStereoToMono.h"

#include <stdio.h>
#include <stdlib.h>

#include "aflibData.h"

aflibAudioStereoToMono::aflibAudioStereoToMono(
   const aflibAudio& audio) : aflibAudio(audio)
{
   // This is a simple class that compbines a stereo data stream to a
   // mono stream. In the future it should be replaced with a more versitile
   // class that will allow much greater options and multi channel.
}


aflibAudioStereoToMono::~aflibAudioStereoToMono()
{
}


aflibStatus
aflibAudioStereoToMono::compute_segment(
   aflibData& data,
   long long position)
{
   aflibStatus ret_status = AFLIB_SUCCESS;
   long sample_length, j;
   int value;
   aflibConfig config;

   data.getLength(sample_length);
   config = data.getConfig();

   // change to one channel now
   config.setChannels(1);
   
   aflibData new_data(config, sample_length);


   for (j = 0; j < sample_length; j++)
   {
      value = (data.getSample(j, 0) + data.getSample(j, 1)) / 2;
      new_data.setSample(value, j, 0);
   }

   data = new_data;

   return (ret_status);
}

