/*
 * Copyright: (C) 1999 Bruce W. Forsberg
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 *
 *   Bruce Forsberg  forsberg@adnc.com
 *
 */


#ifndef _AFLIBAUDIOSTEREOTOMONO_H
#define _AFLIBAUDIOSTEREOTOMONO_H

#include "aflib.h"
#include "aflibAudio.h"


// This class is an example of how to derive from the aflibAudio base class
// and implement an object that can be used in a chain. The default
// constructor is made private so that no one can call it. This is
// because it makes no sense to use this class as the start of a chain.
// This is a very inefficient implemtation. In the future a base class
// should we written that will handle all kinds of mixing. This base
// class should be complex and handle all cases. This class should be
// derived from that one and implement the simple case for the user on
// mixing stereo data to mono. For now it is just a simple example.
//
// compute_segment is implemented from the base class to actually process
// the data. 
//

class aflibConfig;

class aflibAudioStereoToMono : public aflibAudio {

public:

   // Constructor for a node with a parent
   aflibAudioStereoToMono(
      const aflibAudio& audio);

   ~aflibAudioStereoToMono();

   aflibStatus
   compute_segment(aflibData& data,
      long long position = -1) ;

protected:

private:

   aflibAudioStereoToMono();

   aflibAudioStereoToMono(const aflibAudioStereoToMono& op);

   const aflibAudioStereoToMono&
   operator=(const aflibAudioStereoToMono& op);


};


#endif
