/*
 * Copyright: (C) 1999 Bruce W. Forsberg
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 *
 *   Bruce Forsberg  forsberg@adnc.com
 *
 */


#include "aflibChainNode.h"
#include "aflibAudio.h"

#include <stdio.h>
#include <stdlib.h>


aflibChainNode::aflibChainNode(const aflibAudio& audio_item): _audio_item(audio_item)
{
   _id_counter = 0;
}

aflibChainNode::~aflibChainNode()
{
}

int
aflibChainNode::addParent(const aflibAudio& parent_item)
{
  // Add a parent to this node 
  // TBD may need to check in already in list

   _id_counter++;
   // TBD add id_counter
   _audio_parents.push_back(&parent_item);
   return(_id_counter);
}

void
aflibChainNode::removeParent(int parent_id)
{
  // Remove a parent from this node

}

const aflibAudio&
aflibChainNode::getAudioItem()
{
   return (_audio_item);
}

const list<const aflibAudio *>&
aflibChainNode::getParents() const
{
   return _audio_parents;
}







