/*
 * Copyright: (C) 1999 Bruce W. Forsberg
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 *
 *   Bruce Forsberg  forsberg@adnc.com
 *
 */


#ifndef _AFLIBCHAINNODE_H
#define _AFLIBCHAINNODE_H


#include "list.h"
#include "aflib.h"
#include "aflibAudio.h"

// This class contains all of the information about a node in the Chain. This
// class will grow as time goes on. It can be very usefull for debugging
// info. Possibily a print function could be added so that at a higher level
// the entire chain could be navigated and printed out. 
// Convience functions are provided to operate on the data in this
// class. All parents of this audio object that is resented by this node class
// is stored in this class as well.

class aflibChainNode {

public:

   aflibChainNode(const aflibAudio& audio_item);
   ~aflibChainNode();

   int
   addParent(const aflibAudio& parent_item);

   void
   removeParent(int parent_id);

   const aflibAudio&
   getAudioItem();

   const list<const aflibAudio *>&
   getParents() const;

protected:

private:

const aflibAudio&  _audio_item;
list<const aflibAudio *> _audio_parents;
int  _id_counter;

};


#endif
