/*
 * Copyright: (C) 1999 Bruce W. Forsberg
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 *
 *   Bruce Forsberg  forsberg@adnc.com
 *
 */


#ifndef _AFLIBCONFIG_H_
#define _AFLIBCONFIG_H_

#include "aflib.h"

// This class defines how audio data is formatted. This is just a simple
// data class. 


class aflibConfig {

public:

   aflibConfig();

   aflibConfig(
      int num_channels,
      aflib_data_size bits_per_sample,
      int samples_per_second);

   ~aflibConfig();

   int
   getChannels() const
      { return (_channels); };

   void
   setChannels(int channels) 
      { _channels = channels; };

   int
   getBitsPerSample() const
      { return (_bits_per_sample); };

   aflib_data_size
   getSampleSize() const
      { return (_sample_size); };

   void
   setSampleSize(aflib_data_size bits_per_sample)
      { _sample_size = bits_per_sample; _bits_per_sample = returnBitsPerSample(_sample_size); };

   int
   getSamplesPerSecond() const
      { return (_samples_per_second); };

   void
   setSamplesPerSecond(int samples_per_second)
      { _samples_per_second = samples_per_second; };

   aflib_data_orientation
   getDataOrientation() const
      { return (_data_orientation); };

   void
   setDataOrientation(aflib_data_orientation data_orientation)
      { _data_orientation = data_orientation; };

   aflib_data_quality
   getDataQuality() const
      { return (_quality); };

   void
   setDataQuality(aflib_data_quality data_quality)
      { _quality = data_quality; };

   long long 
   getTotalSamples() const 
      { return(_total_size); };

   void
   setTotalSamples(long long total)
      { _total_size = total; };

private:

   int
   returnBitsPerSample(aflib_data_size size);

   int _channels;
   int _bits_per_sample;
   aflib_data_size  _sample_size;
   int _samples_per_second;
   aflib_data_orientation _data_orientation;
   aflib_data_quality  _quality;
   long long  _total_size;

};


#endif
