/*
 * Copyright: (C) 1999 Bruce W. Forsberg
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 *
 *   Bruce Forsberg  forsberg@adnc.com
 *
 */


#include <stdio.h>

#include "aflib.h"
#include "aflibDateTime.h"


aflibDateTime::aflibDateTime() :
   _year(-1),
   _month(-1),
   _day(-1),
   _hour(-1),
   _minute(-1),
   _second(-1)
{
}

aflibDateTime::aflibDateTime (
   int  year,
   int  month,
   int  day,
   int  hour,
   int  minute,
   int  second) :
   _year(year),
   _month(month),
   _day(day),
   _hour(hour),
   _minute(month),
   _second(second)
{
}


aflibDateTime::~aflibDateTime()
{
}

bool
aflibDateTime::operator < (const aflibDateTime& date) const
{
   if (getYear() < date.getYear())
      return (TRUE);
   else if (getYear() > date.getYear())
      return (FALSE);

   if (getMonth() < date.getMonth())
      return (TRUE);
   else if (getMonth() > date.getMonth())
      return (FALSE);

   if (getDay() < date.getDay())
      return (TRUE);
   else if (getDay() > date.getDay())
      return (FALSE);

   if (getHour() < date.getHour())
      return (TRUE);
   else if (getHour() > date.getHour())
      return (FALSE);

   if (getMinute() < date.getMinute())
      return (TRUE);
   else if (getMinute() > date.getMinute())
      return (FALSE);

   if (getSecond() < date.getSecond())
      return (TRUE);
   else if (getSecond() > date.getSecond())
      return (FALSE);

   return (FALSE);
   
}

void
aflibDateTime::setYear(int year)
{
   _year = year;
}

int
aflibDateTime::getYear() const
{
   return(_year);
}

void
aflibDateTime::setMonth(int month)
{
   _month = month;
}

int
aflibDateTime::getMonth() const
{
   return(_month);
}

void
aflibDateTime::setDay(int day)
{
   _day = day;
}

int
aflibDateTime::getDay() const
{
   return(_day);
}

void
aflibDateTime::setHour(int hour)
{
   _hour = hour;
}

int
aflibDateTime::getHour() const
{
   return(_hour);
}

void
aflibDateTime::setMinute(int minute)
{
   _minute = minute;
}

int
aflibDateTime::getMinute() const
{
   return(_month);
}

void
aflibDateTime::setSecond(int second)
{
   _second = second;
}

int
aflibDateTime::getSecond() const
{
   return(_second);
}


