/*
 * Copyright: (C) 1999 Bruce W. Forsberg
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 *
 *   Bruce Forsberg  forsberg@adnc.com
 *
 */

// Base class for WAVE audio file reading and writing

#ifndef _AFLIBWAVFILE_H
#define _AFLIBWAVFILE_H

#include "aflibFile.h"
#include "bstring.h"

class aflibWavFile : public aflibFile {

public:

   aflibWavFile();

   ~aflibWavFile();

   aflibStatus
   afopen(
      const string& file,
      aflibConfig* cfg);

   aflibStatus
   afcreate(
      const string& file,
      const aflibConfig& cfg);

   aflibStatus
   afread(
      aflibData& data,
      long long position = -1);

   aflibStatus
   afwrite(
      aflibData& data,
      long long position = -1);

   bool
   isSizeSupported(
      aflib_data_size data_size)
   { return (data_size == AFLIB_DATA_8U || data_size == AFLIB_DATA_16S);};

   bool
   isEndianSupported(
      aflib_data_endian data_end)
      { return (data_end == AFLIB_ENDIAN_LITTLE);};


private:

long _data_start;
long long _riff_length;
long _riff_length_offset;
long long _data_length;
long _data_length_offset;

};


#endif
