#include "l3stereo.h"

const FLOAT INV_SQRT_2 = 0.707106781186547;
const FLOAT m_thresh[] = { 0.0, 0.0, 0.0, 0.0, 0.0,
			   0.1, 0.1, 0.1, 0.1, 0.1,
			   0.1, 0.2, 0.3, 0.4, 0.5,
			   0.6, 0.7, 0.8, 0.9, 1.0, 1.5 };

static int mbit = 0, lbit = 0;

void III_stereo (double (*mdct_freq)[2][576], int stereo, int mode_gr,
		 frame_params *fr_ps, III_side_info_t *l3_side, double (*energy_sum)[2])
{
	double (*xrp)[2][32][18] = (double (*)[2][32][18]) mdct_freq;
	layer   *info = fr_ps->header;
	FLOAT l, r, m, s, lr2,  s2, olr2, os2;
	int   i, j, do_ms, ch, gr;
	
	/* ms_stereo switching */
	do_ms = fr_ps->actual_mode == MPG_MD_JOINT_STEREO &&
		((*energy_sum)[0] - (*energy_sum)[1]) <
		0.8 * ((*energy_sum)[0] + (*energy_sum)[1]);
#if 1
	for (gr = 0; gr < mode_gr; gr++) {
		for (ch = 0; ch < stereo; ch++)
			do_ms &= ((gr_info *)&(l3_side->gr[gr].ch[ch]))->block_type != 2;
	}
#endif
	
	if (!do_ms)
		info->mode_ext = 0;
	else {
		/* ms_stereo processing */
		info->mode_ext = 2;
		for (gr = 0; gr < mode_gr; gr++) {
			for (j = 0; j < 18; j++) {
#if 0
				for (i = 0; i < SBLIMIT; i++) {
					//l = xrp[gr][0][i][j];
					//r = xrp[gr][1][i][j];
					//m = (r + l) * INV_SQRT_2;
					if (i == mbit && j == lbit)
						xrp[gr][0][i][j] = 1.0;
					else
						xrp[gr][0][i][j] = 0.0;
					xrp[gr][1][i][j] = 0.0;

				}
#endif
#if 1
				for (i = 0; i < 21; i++) {
					l = xrp[gr][0][i][j];
					r = xrp[gr][1][i][j];
					m = (r + l) * INV_SQRT_2;
					s = (l - r) * INV_SQRT_2;
					lr2 = l*l + r*r; s2 = s*s;
					xrp[gr][0][i][j] = m;
#if 0
					/* sparsing of side channel */
					if (i > 8 /* 1 really, but only 0.0 in m_thresh[0--4] */ &&
					    (s2 + os2) < m_thresh[i]*(lr2+olr2)) {
						xrp[gr][1][i-1][j] = 0.0;
						xrp[gr][1][i][j]   = 0.0;
					} else
#endif
						xrp[gr][1][i][j] = s;
					/* save last results (i-1) */
					olr2 = lr2; os2 = s2;
				}
				
				for (; i < SBLIMIT; i++) {
					l = xrp[gr][0][i][j];
					r = xrp[gr][1][i][j];
					m = (r + l) * INV_SQRT_2;
					xrp[gr][0][i][j] = m;
					xrp[gr][1][i][j] = 0.0;
				}
#endif
			}
		}
	}
#if 0
	if (++lbit == 18) {
		lbit = 0;
		if (++mbit == 32)
			mbit = 0;
	}
#endif
}
